# class KLineEdit | An enhanced single line input widget. More...
Definition | `#include <klineedit.h>`
Inherits | KCompletionBase (kdecore) [public ], QLineEdit (qt) [public ]
Inherited by | KListViewLineEdit, KRestrictedLine
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KLineEdit ( const QString &string, QWidget *parent, const char *name = 0 )
- KLineEdit ( QWidget *parent=0, const char *name=0 )
- virtual ~KLineEdit ()
- void setURL ( const KURL& url )
- void cursorAtEnd ()
- virtual void setCompletionMode ( KGlobalSettings::Completion mode )
- virtual void setContextMenuEnabled ( bool showMenu )
- bool isContextMenuEnabled () const
- void setURLDropsEnabled ( bool enable )
- bool isURLDropsEnabled () const
- void setTrapReturnKey ( bool trap )
- bool trapReturnKey () const
- KCompletionBox * completionBox ()

#### Public Slots

- void rotateText ( KCompletionBase::KeyBindingType )
- virtual void setCompletedText ( const QString& )
- void setCompletedItems ( const QStringList& items )

#### Signals

- void returnPressed ( const QString& )
- void completion ( const QString& )
- void textRotation ( KCompletionBase::KeyBindingType )
- void completionModeChanged ( KGlobalSettings::Completion )

#### Protected Methods

- virtual void keyPressEvent ( QKeyEvent * )
- virtual void mousePressEvent ( QMouseEvent * )
- virtual void dropEvent ( QDropEvent * )
- virtual void setCompletedText ( const QString& , bool )

#### Protected Slots

- virtual void makeCompletion ( const QString& )
- void slotAboutToShow ()
- void slotCancelled ()

## Detailed Description

An enhanced QLineEdit widget for inputting text.

### Detail

This widget inherits from QLineEdit and implements the following additional functionalities: q completion object that provides both automatic and manual text completion as well as multiple match iteration features, configurable key-bindings to activate these features and a popup-menu item that can be used to allow the user to set text completion modes on the fly based on their preference.

To support these new features KLineEdit also emits a few more additional signals. These are: completion( const QString& ), textRotation( KeyBindingType ), and returnPressed( const QString& ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text. The text rotation signal is intended to be used to iterate through the list of all possible matches whenever there is more than one match for the entered text. The `returnPressed`( const QString& ) signals are the same as QLineEdit's except it provides the current text in the widget as its argument whenever appropriate.

This widget by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KLineEdit will by default handle the text rotation and completion events internally when a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase::setHandleSignals( bool ) or set the boolean parameter in the above functions to FALSE.

The default key-bindings for completion and rotation is determined from the global settings in KStdAccel. These values, however, can be overriden locally by invoking KCompletionBase::setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

NOTE that if the `EchoMode` for this widget is set to something other than `QLineEdit::Normal`, the completion mode will always be defaulted to KGlobal::CompletionNone. This is done purposefully to guard against protected entries such as passwords being cached in KCompletion's list. Hence, if the `EchoMode` is not QLineEdit::Normal, the completion mode is automatically disabled.

### Examples

To enable the basic completion feature :

     KLineEdit *edit = new KLineEdit( this, "mywidget" );
     KCompletion *comp = edit->completionObject();
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

To use a customized completion objects or your own completion object :

     KLineEdit *edit = new KLineEdit( this,"mywidget" );
     KURLCompletion *comp = new KURLCompletion();
     edit->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

### Miscellaneous function calls :

     // Tell the widget not to handle completion and
     // iteration internally.
     edit->setHandleSignals( false );
     // Set your own completion key for manual completions.
     edit->setKeyBinding( KCompletionBase::TextCompletion, Qt::End );
     // Hide the context (popup) menu
     edit->setContextMenuEnabled( false );
     // Temporarly disable signal emitions
     // (both completion & iteration signals)
     edit->disableSignals();
     // Default the key-bindings to system settings.
     edit->useGlobalKeyBindings();

KLineEdit ( const QString &string, QWidget *parent, const char *name = 0 ) | ### KLineEdit

Construct a KLineEdit object with a default text, a parent, and a name.

Parameters:

string | Text to be shown in the edit widget.
parent | The parent object of this widget.
name | the name of this widget

KLineEdit ( QWidget *parent=0, const char *name=0 ) | ### KLineEdit

Construct a KLineEdit object with a parent and a name.

Parameters:

string | Text to be shown in the edit widget.
parent | The parent object of this widget.
name | The name of this widget.

~KLineEdit () | ### ~KLineEdit

[virtual]

Destructor.

void setURL ( const KURL& url ) | ### setURL

Sets `url` into the lineedit. It uses KURL::prettyURL() so that the url is properly decoded for displaying.

void cursorAtEnd () | ### cursorAtEnd

Put cursor at the end of the string.

This method is deprecated. Use QLineEdit::end() instead.

QLineEdit::end()

void setCompletionMode ( KGlobalSettings::Completion mode ) | ### setCompletionMode

[virtual]

Re-implemented from KCompletionBase for internal reasons.

This function is re-implemented in order to make sure that the EchoMode is acceptable before we set the completion mode.

See KCompletionBase::setCompletionMode

Reimplemented from KCompletionBase.

void setContextMenuEnabled ( bool showMenu ) | ### setContextMenuEnabled

[virtual]

Enables/disables the popup (context) menu.

Note that when this function is invoked with its argument set to `true`, then both the context menu and the completion menu item are enabled. If you do not want to the completion item to be visible simply invoke hideModechanger() right after calling this method. Also by default, the context menu is automatically created if this widget is editable. Thus you need to call this function with the argument set to false if you do not want this behaviour.

Parameters:

showMenu | If `true`, show the context menu.

bool isContextMenuEnabled () | ### isContextMenuEnabled

[const]

Returns `true` when the context menu is enabled.

Returns: `true` If context menu is enabled.

void setURLDropsEnabled ( bool enable ) | ### setURLDropsEnabled

Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behaviour of QLineEdit is used, which inserts the encoded URL.

Parameters:

enable | If `true`, insert decoded URLs

bool isURLDropsEnabled () | ### isURLDropsEnabled

[const]

Returns `true` when decoded URL drops are enabled

Returns: `true` if decoded URL drops are enabled

void setTrapReturnKey ( bool trap ) | ### setTrapReturnKey

By default, KComboBox recognizes `Key_Return` and `Key_Enter` and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.

Call this method with `trap` = `true` to make `KComboBox` stop these events. The signals will still be emitted of course.

Only affects read-writable comboboxes.

See also: trapReturnKey()

bool trapReturnKey () | ### trapReturnKey

[const]

Returns: `true` if keyevents of `Key_Return` or `Key_Enter` will be stopped or if they will be propagated.

See also: setTrapReturnKey, ()

bool eventFilter ( QObject *, QEvent * ) | ### eventFilter

[virtual]

Re-implemented for internal reasons. API not affected.

KCompletionBox * completionBox () | ### completionBox

Returns: the completion-box, that is used in completion mode KGlobalSettings::CompletionPopup. This method will create a completion-box by calling makeCompletionBox, if none is there, yet.

void returnPressed ( const QString& ) | ### returnPressed

[signal]

Emitted when the user presses the return key.

The argument is the current text. Note that this signal is not emitted if the widget's `EchoMode` is set to QLineEdit::Password.

Reimplemented from QLineEdit.

void completion ( const QString& ) | ### completion

[signal]

Emitted when the completion key is pressed.

Please note that this signal is not emitted if the completion mode is set to `CompletionNone` or `EchoMode` is normal.

void textRotation ( KCompletionBase::KeyBindingType ) | ### textRotation

[signal]

Emitted when the text rotation key-bindings are pressed.

The argument indicates which key-binding was pressed. In KLineEdit's case this can be either one of two values: PrevCompletionMatch or NextCompletionMatch. See KCompletionBase::setKeyBinding for details.

Note that this signal is not emitted if the completion mode is set to `CompletionNone` or `EchoMode` is not normal.

void completionModeChanged ( KGlobalSettings::Completion ) | ### completionModeChanged

[signal]

Emitted when the user changed the completion mode by using the popupmenu.

void rotateText ( KCompletionBase::KeyBindingType ) | ### rotateText

[slot]

Iterate through all possible matches of the completed text or the history list.

This function simply iterates over all possible matches in case multimple matches are found as a result of a text completion request. It will have no effect if only a single match is found.

Parameters:

type | The key-binding invoked.

void setCompletedText ( const QString& ) | ### setCompletedText

[virtual slot]

Reimplemented from KCompletionBase.

void setCompletedItems ( const QStringList& items ) | ### setCompletedItems

[slot]

Sets `items` into the completion-box if completionMode() is CompletionPopup. The popup will be shown immediately.

void makeCompletion ( const QString& ) | ### makeCompletion

[protected slots virtual slot]

Complete the remaining text with a matching one from a given list.

void slotAboutToShow () | ### slotAboutToShow

[protected slots slot]

Stores the current text whenever the completion box is displayed for the first time.

void slotCancelled () | ### slotCancelled

[protected slots slot]

Re-stores the current text if the completion box is cancelled by the user.

void keyPressEvent ( QKeyEvent * ) | ### keyPressEvent

[protected virtual]

Re-implemented for internal reasons. API not affected.

See QLineEdit::keyPressEvent().

Reimplemented from QLineEdit.

void mousePressEvent ( QMouseEvent * ) | ### mousePressEvent

[protected virtual]

Re-implemented for internal reasons. API not affected.

See QLineEdit::mousePressEvent().

Reimplemented from QLineEdit.

void dropEvent ( QDropEvent * ) | ### dropEvent

[protected virtual]

Re-implemented to handle URI drops.

See QLineEdit::dropEvent().

Reimplemented from QLineEdit.

void setCompletedText ( const QString& , bool ) | ### setCompletedText

[protected virtual]

Reimplemented from KCompletionBase.

- Author: Dawit Alemayehu <adawit@kde.org>
- Generated: root@i386.ports.openbsd.org on Wed Apr 25 13:58:24 2001, using kdoc 2.0a53.